Index: LinearAlgebra/src/LinearAlgebra/Line.cpp
===================================================================
--- LinearAlgebra/src/LinearAlgebra/Line.cpp	(revision ce7bfd57176b8ad23e9bfcc393a41c4798df77ed)
+++ LinearAlgebra/src/LinearAlgebra/Line.cpp	(revision 50c35d7a80a86a8cda3eba3bc522fa468ed79feb)
@@ -34,4 +34,5 @@
 #include "MatrixContent.hpp"
 #include "Plane.hpp"
+#include "RealSpaceMatrix.hpp"
 #include "Vector.hpp"
 
@@ -261,4 +262,12 @@
 }
 
+RealSpaceMatrix Line::getRotationMatrix(double alpha) const
+{
+  RealSpaceMatrix M;
+  M.setRotation(getDirection(), alpha);
+
+  return M;
+}
+
 Plane Line::getOrthogonalPlane(const Vector &origin) const{
   return Plane(getDirection(),origin);
Index: LinearAlgebra/src/LinearAlgebra/Line.hpp
===================================================================
--- LinearAlgebra/src/LinearAlgebra/Line.hpp	(revision ce7bfd57176b8ad23e9bfcc393a41c4798df77ed)
+++ LinearAlgebra/src/LinearAlgebra/Line.hpp	(revision 50c35d7a80a86a8cda3eba3bc522fa468ed79feb)
@@ -24,4 +24,5 @@
 class Plane;
 class LinePoint;
+class RealSpaceMatrix;
 
 /** This class represents a line in space stretching to infinity.
@@ -55,4 +56,5 @@
   Line rotateLine(const Line &rhs, double alpha) const;
   Plane rotatePlane(const Plane &rhs, double alpha) const;
+  RealSpaceMatrix getRotationMatrix(double alpha) const;
 
   Plane getOrthogonalPlane(const Vector &origin) const;
Index: LinearAlgebra/src/LinearAlgebra/RealSpaceMatrix.cpp
===================================================================
--- LinearAlgebra/src/LinearAlgebra/RealSpaceMatrix.cpp	(revision ce7bfd57176b8ad23e9bfcc393a41c4798df77ed)
+++ LinearAlgebra/src/LinearAlgebra/RealSpaceMatrix.cpp	(revision 50c35d7a80a86a8cda3eba3bc522fa468ed79feb)
@@ -142,4 +142,30 @@
 }
 
+void RealSpaceMatrix::setRotation(const Vector &axis, const double alpha)
+{
+  ASSERT( fabs(axis.Norm() - 1.) < LINALG_MYEPSILON(),
+      "RealSpaceMatrix::setRotation() - axis is not normalized.");
+
+  // this is taken from http://inside.mines.edu/~gmurray/ArbitraryAxisRotation/, section 5.
+  const double u = axis[0];
+  const double v = axis[1];
+  const double w = axis[2];
+  const double u_squared = u*u;
+  const double v_squared = v*v;
+  const double w_squared = w*w;
+  const double cos_alpha = cos(alpha);
+  const double cos_alpha_inv = 1.-cos(alpha);
+  const double sin_alpha = sin(alpha);
+  set(0,0, u_squared + (v_squared + w_squared)*cos_alpha );
+  set(1,1, v_squared + (u_squared + w_squared)*cos_alpha );
+  set(2,2, w_squared + (u_squared + v_squared)*cos_alpha );
+  set(0,1, u*v*cos_alpha_inv - w*sin_alpha );
+  set(0,2, u*w*cos_alpha_inv + v*sin_alpha );
+  set(1,0, u*v*cos_alpha_inv + w*sin_alpha );
+  set(1,2, v*w*cos_alpha_inv - u*sin_alpha );
+  set(2,0, u*w*cos_alpha_inv - v*sin_alpha );
+  set(2,1, v*w*cos_alpha_inv + u*sin_alpha );
+}
+
 RealSpaceMatrix &RealSpaceMatrix::operator=(const RealSpaceMatrix &src)
 {
Index: LinearAlgebra/src/LinearAlgebra/RealSpaceMatrix.hpp
===================================================================
--- LinearAlgebra/src/LinearAlgebra/RealSpaceMatrix.hpp	(revision ce7bfd57176b8ad23e9bfcc393a41c4798df77ed)
+++ LinearAlgebra/src/LinearAlgebra/RealSpaceMatrix.hpp	(revision 50c35d7a80a86a8cda3eba3bc522fa468ed79feb)
@@ -84,4 +84,14 @@
    */
   void setRotation(const double phi[NDIM]);
+
+  /**
+   * Sets all matrix corresponding to a rotation matrix,
+   * around the given \a axis by angle \a phi.
+   *
+   * @param axis \b normalized rotation axis
+   * @param alpha rotation angle
+   */
+  void setRotation(const Vector &axis, const double alpha);
+
   /**
    * Access the matrix at index (i,j)
Index: LinearAlgebra/src/unittests/LineUnitTest.cpp
===================================================================
--- LinearAlgebra/src/unittests/LineUnitTest.cpp	(revision ce7bfd57176b8ad23e9bfcc393a41c4798df77ed)
+++ LinearAlgebra/src/unittests/LineUnitTest.cpp	(revision 50c35d7a80a86a8cda3eba3bc522fa468ed79feb)
@@ -30,4 +30,6 @@
 
 #include "LineUnitTest.hpp"
+
+#include "RealSpaceMatrix.hpp"
 
 #ifdef HAVE_TESTRUNNER
@@ -297,5 +299,4 @@
 
 
-
   // now the real rotations
   // unitVec[1] around unitVec[0]
@@ -364,4 +365,51 @@
 }
 
+void LineUnittest::getRotationMatrixTest()
+{
+  RealSpaceMatrix M;
+  Vector fixture;
+
+  // check getRotationMatrix;
+  M = la1->getRotationMatrix(1.);
+  fixture = M * unitVec[0];
+  CPPUNIT_ASSERT_EQUAL(fixture,unitVec[0]);
+  M = la2->getRotationMatrix(1.);
+  fixture = M * unitVec[1];
+  CPPUNIT_ASSERT_EQUAL(fixture,unitVec[1]);
+  M = la3->getRotationMatrix(1.);
+  fixture = M * unitVec[2];
+  CPPUNIT_ASSERT_EQUAL(fixture,unitVec[2]);
+
+  // unitVec[1] around unitVec[0]
+  fixture = la1->rotateVector(unitVec[1],0);
+  CPPUNIT_ASSERT_EQUAL(fixture,unitVec[1]);
+  fixture = la1->rotateVector(unitVec[1],1./2.*M_PI);
+  CPPUNIT_ASSERT_EQUAL(fixture,-1*unitVec[2]);
+  fixture = la1->rotateVector(unitVec[1],M_PI);
+  CPPUNIT_ASSERT_EQUAL(fixture,-1*unitVec[1]);
+  fixture = la1->rotateVector(unitVec[1],2*M_PI);
+  CPPUNIT_ASSERT_EQUAL(fixture,unitVec[1]);
+
+  // unitVec[2] around unitVec[1]
+  fixture = la2->rotateVector(unitVec[2],0);
+  CPPUNIT_ASSERT_EQUAL(fixture,unitVec[2]);
+  fixture = la2->rotateVector(unitVec[2],1./2.*M_PI);
+  CPPUNIT_ASSERT_EQUAL(fixture,-1*unitVec[0]);
+  fixture = la2->rotateVector(unitVec[2],M_PI);
+  CPPUNIT_ASSERT_EQUAL(fixture,-1*unitVec[2]);
+  fixture = la2->rotateVector(unitVec[2],2*M_PI);
+  CPPUNIT_ASSERT_EQUAL(fixture,unitVec[2]);
+
+  // unitVec[0] around unitVec[2]
+  fixture = la3->rotateVector(unitVec[0],0);
+  CPPUNIT_ASSERT_EQUAL(fixture,unitVec[0]);
+  fixture = la3->rotateVector(unitVec[0],1./2.*M_PI);
+  CPPUNIT_ASSERT_EQUAL(fixture,-1*unitVec[1]);
+  fixture = la3->rotateVector(unitVec[0],M_PI);
+  CPPUNIT_ASSERT_EQUAL(fixture,-1*unitVec[0]);
+  fixture = la3->rotateVector(unitVec[0],2*M_PI);
+  CPPUNIT_ASSERT_EQUAL(fixture,unitVec[0]);
+}
+
 void LineUnittest::sphereIntersectionTest(){
   {
Index: LinearAlgebra/src/unittests/LineUnitTest.hpp
===================================================================
--- LinearAlgebra/src/unittests/LineUnitTest.hpp	(revision ce7bfd57176b8ad23e9bfcc393a41c4798df77ed)
+++ LinearAlgebra/src/unittests/LineUnitTest.hpp	(revision 50c35d7a80a86a8cda3eba3bc522fa468ed79feb)
@@ -23,10 +23,11 @@
 
   CPPUNIT_TEST_SUITE( LineUnittest) ;
-  CPPUNIT_TEST ( constructionErrorTest );
-  CPPUNIT_TEST ( constructionResultTest );
-  CPPUNIT_TEST ( isContainedTest );
-  CPPUNIT_TEST ( intersectionTest );
-  CPPUNIT_TEST ( rotationTest );
-  CPPUNIT_TEST ( sphereIntersectionTest );
+//  CPPUNIT_TEST ( constructionErrorTest );
+//  CPPUNIT_TEST ( constructionResultTest );
+//  CPPUNIT_TEST ( isContainedTest );
+//  CPPUNIT_TEST ( intersectionTest );
+//  CPPUNIT_TEST ( rotationTest );
+  CPPUNIT_TEST ( getRotationMatrixTest );
+//  CPPUNIT_TEST ( sphereIntersectionTest );
   CPPUNIT_TEST_SUITE_END();
 
@@ -40,4 +41,5 @@
   void intersectionTest();
   void rotationTest();
+  void getRotationMatrixTest();
   void sphereIntersectionTest();
 
Index: LinearAlgebra/src/unittests/RealSpaceMatrixUnitTest.cpp
===================================================================
--- LinearAlgebra/src/unittests/RealSpaceMatrixUnitTest.cpp	(revision ce7bfd57176b8ad23e9bfcc393a41c4798df77ed)
+++ LinearAlgebra/src/unittests/RealSpaceMatrixUnitTest.cpp	(revision 50c35d7a80a86a8cda3eba3bc522fa468ed79feb)
@@ -31,4 +31,6 @@
 #include <boost/archive/text_iarchive.hpp>
 
+#include "CodePatterns/Assert.hpp"
+
 #include "defs.hpp"
 #include "Exceptions.hpp"
@@ -45,4 +47,7 @@
 
 void RealSpaceMatrixTest::setUp(){
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
   zero = new RealSpaceMatrix();
   for(int i =NDIM;i--;) {
@@ -270,4 +275,5 @@
   RealSpaceMatrix res;
   RealSpaceMatrix inverse;
+  Vector fixture;
 
   // zero rotation angles yields unity matrix
@@ -287,4 +293,31 @@
   res.setRotation(M_PI/3.,0.,0.);
   CPPUNIT_ASSERT_EQUAL(inverse, res.transposed());
+
+  // check arbitrary axis
+  res.setRotation(unitVec[0], M_PI/3.);
+  inverse.setRotation(M_PI/3.,0.,0.);
+  CPPUNIT_ASSERT_EQUAL( res, inverse);
+  res.setRotation(unitVec[1], M_PI/3.);
+  inverse.setRotation(0., M_PI/3.,0.);
+  CPPUNIT_ASSERT_EQUAL( res, inverse);
+  res.setRotation(unitVec[2], M_PI/3.);
+  inverse.setRotation(0.,0.,M_PI/3.);
+  CPPUNIT_ASSERT_EQUAL( res, inverse);
+
+  // check axis not normalized throws
+#ifndef NDEBUG
+  CPPUNIT_ASSERT_THROW( res.setRotation(unitVec[0]+unitVec[1], M_PI/3.),Assert::AssertionFailure);
+#endif
+
+  // check arbitrary axis and det=1
+  fixture = (unitVec[0]+unitVec[1]).getNormalized();
+  res.setRotation(fixture, M_PI/3.);
+  CPPUNIT_ASSERT(fabs(res.determinant() - 1.) <= LINALG_MYEPSILON());
+  fixture = (unitVec[1]+unitVec[2]).getNormalized();
+  res.setRotation(fixture, M_PI/3.);
+  CPPUNIT_ASSERT(fabs(res.determinant() - 1.) <= LINALG_MYEPSILON());
+  fixture = (unitVec[1]+unitVec[2]).getNormalized();
+  res.setRotation(fixture, M_PI/3.);
+  CPPUNIT_ASSERT(fabs(res.determinant() - 1.) <= LINALG_MYEPSILON());
 }
 