Index: tests/regression/Selection/Atoms/AtomByOrder/testsuite-selection-select-atom-by-order.at
===================================================================
--- tests/regression/Selection/Atoms/AtomByOrder/testsuite-selection-select-atom-by-order.at	(revision 61c364e5234bfac462d451e14f2d8a128787f6bb)
+++ tests/regression/Selection/Atoms/AtomByOrder/testsuite-selection-select-atom-by-order.at	(revision 61c364e5234bfac462d451e14f2d8a128787f6bb)
@@ -0,0 +1,87 @@
+### 6. (un)select atom by order
+
+AT_SETUP([Selection - atom with specific order])
+AT_KEYWORDS([selection order atom select-atom-by-order])
+# go through all possible orders (0-7) and removed
+i=1
+while test $i -le 8; do
+  let id=$i-1
+  file=id${id}_missing.xyz
+  # normal
+  AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/pre/test.xyz $file])
+  AT_CHECK([chmod u+w $file], 0)
+  AT_CHECK([../../molecuilder -i $file -v 3 --select-atom-by-order ${i} -r], [], [ignore], [ignore])
+  AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/post/id${id}_missing.xyz])
+  ((i+=1))
+done
+# go through all possible orders (0-7) and removed
+i=1
+while test $i -le 8; do
+  let id=8-$i
+  file=id${id}_missing.xyz
+  # normal
+  AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/pre/test.xyz $file])
+  AT_CHECK([chmod u+w $file], 0)
+  AT_CHECK([../../molecuilder -i $file -v 3 --select-atom-by-order -${i} -r], [], [ignore], [ignore])
+  AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/post/id${id}_missing.xyz])
+  ((i+=1))
+done
+AT_CLEANUP
+
+
+AT_SETUP([Selection - atom with specific order with Undo])
+AT_KEYWORDS([selection order atom select-atom-by-order undo])
+# go through all possible ids (0-7) and removed
+i=1
+while test $i -le 8; do
+  let id=$i-1
+  file=id${id}_missing.xyz
+  # undo
+  AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/pre/test.xyz $file])
+  AT_CHECK([chmod u+w $file], 0)
+  AT_CHECK([../../molecuilder -i $file -v 3 --select-atom-by-order ${i} --undo -r], [], [ignore], [ignore])
+  AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/post/test-undo.xyz])
+  ((i+=1))
+done
+# go reverse through all possible ids (0-7) and removed
+i=1
+while test $i -le 8; do
+  let id=8-$i
+  file=id${id}_missing.xyz
+  # undo
+  AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/pre/test.xyz $file])
+  AT_CHECK([chmod u+w $file], 0)
+  AT_CHECK([../../molecuilder -i $file -v 3 --select-atom-by-order -${i} --undo -r], [], [ignore], [ignore])
+  AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/post/test-undo.xyz])
+  ((i+=1))
+done
+AT_CLEANUP
+
+
+AT_SETUP([Selection - atom with specific order with Redo])
+AT_KEYWORDS([selection order atom select-atom-by-order redo])
+# go through all possible ids (0-7) and removed
+i=1
+while test $i -le 8; do
+  let id=$i-1
+  file=id${id}_missing.xyz
+  # redo
+  AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/pre/test.xyz $file])
+  AT_CHECK([chmod u+w $file], 0)
+  AT_CHECK([../../molecuilder -i $file -v 3 --select-atom-by-order ${i} --undo --redo -r], [], [ignore], [ignore])
+  AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/post/id${id}_missing.xyz])
+  ((i+=1))
+done
+# go reverse through all possible ids (0-7) and removed
+i=1
+while test $i -le 8; do
+  let id=8-$i
+  file=id${id}_missing.xyz
+  # redo
+  AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/pre/test.xyz $file])
+  AT_CHECK([chmod u+w $file], 0)
+  AT_CHECK([../../molecuilder -i $file -v 3 --select-atom-by-order -${i} --undo --redo -r], [], [ignore], [ignore])
+  AT_CHECK([diff -I '.*Created by molecuilder.*' $file ${abs_top_srcdir}/tests/regression/Selection/Atoms/AtomByOrder/post/id${id}_missing.xyz])
+  ((i+=1))
+done
+AT_CLEANUP